Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/AfterMutationCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/AfterMutationCombinedOperator.cs	(revision 9032)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/AfterMutationCombinedOperator.cs	(revision 9042)
@@ -38,8 +38,17 @@
     }
 
+    [Storable]
+    protected MutationPerformanceAnalyzer mAnalyzer;
+    [Storable]
+    protected VariableRemover varRemover;
+    [Storable]
+    protected IEvaluator evaluatorClone;
+
     [StorableConstructor]
     protected AfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
     protected AfterMutationCombinedOperator(AfterMutationCombinedOperator original, Cloner cloner)
       : base(original, cloner) {
+      this.mAnalyzer = (MutationPerformanceAnalyzer)original.mAnalyzer.Clone(cloner);
+      this.varRemover = (VariableRemover)original.varRemover.Clone(cloner);
     }
 
@@ -52,5 +61,5 @@
     }
 
-    void SimilarityCalculatorParameter_ValueChanged(object sender, System.EventArgs e) {
+    protected virtual void SimilarityCalculatorParameter_ValueChanged(object sender, System.EventArgs e) {
       SimilarityCalculatorParameter.Value.QualityVariableName = "TSPTourLength";
       SimilarityCalculatorParameter.Value.SolutionVariableName = "TSPTour";
@@ -62,8 +71,8 @@
 
     public override void InitializeOperators() {
-      var evaluatorClone = (IEvaluator)EvaluatorParameter.ActualValue.Clone();
+      evaluatorClone = (IEvaluator)EvaluatorParameter.ActualValue.Clone();
       ((ILookupParameter)evaluatorClone.Parameters["Quality"]).ActualName = "TSPTourLengthM";
-      var mAnalyzer = new MutationPerformanceAnalyzer();
-      var varRemover = new VariableRemover();
+      mAnalyzer = new MutationPerformanceAnalyzer();
+      varRemover = new VariableRemover();
 
       Operators.Add(evaluatorClone);
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9032)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9042)
@@ -120,4 +120,7 @@
     <Compile Include="AfterCrossoverCombinedOperator.cs" />
     <Compile Include="AfterMutationCombinedOperator.cs" />
+    <Compile Include="TSPAfterMutationCombinedOperator.cs" />
+    <Compile Include="TSPAfterCrossoverCombinedOperator.cs" />
+    <Compile Include="QAPAfterMutationCombinedOperator.cs" />
     <Compile Include="QAPAfterCrossoverCombinedOperator.cs" />
     <Compile Include="InitializableOperator.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/QAPAfterMutationCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/QAPAfterMutationCombinedOperator.cs	(revision 9042)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/QAPAfterMutationCombinedOperator.cs	(revision 9042)
@@ -0,0 +1,60 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("QAPAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for the QAP.")]
+  [StorableClass]
+  public class QAPAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+    [StorableConstructor]
+    protected QAPAfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
+    protected QAPAfterMutationCombinedOperator(QAPAfterMutationCombinedOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public QAPAfterMutationCombinedOperator()
+      : base() { }
+
+    protected override void SimilarityCalculatorParameter_ValueChanged(object sender, System.EventArgs e) {
+      SimilarityCalculatorParameter.Value.QualityVariableName = "Quality";
+      SimilarityCalculatorParameter.Value.SolutionVariableName = "Assignment";
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new QAPAfterMutationCombinedOperator(this, cloner);
+    }
+
+    public override void InitializeOperators() {
+      base.InitializeOperators();
+      ((ILookupParameter)evaluatorClone.Parameters["Quality"]).ActualName = "QualityM";
+
+      mAnalyzer.QualityAfterCrossoverParameter.ActualName = "Quality";
+      mAnalyzer.QualityAfterMutationParameter.ActualName = "QualityM";
+      mAnalyzer.PermutationBeforeMutationParameter.ActualName = "AssignmentClone";
+      mAnalyzer.PermutationAfterMutationParameter.ActualName = "Assignment";
+
+      varRemover.VariableNameParameter.Value.Value = "TSPTourClone";
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterCrossoverCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterCrossoverCombinedOperator.cs	(revision 9042)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterCrossoverCombinedOperator.cs	(revision 9042)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("TSPAfterCrossoverCombinedOperator", "An operator that contains all operators that need to be executed after crossover for the TSP.")]
+  [StorableClass]
+  public class TSPAfterCrossoverCombinedOperator : AfterCrossoverCombinedOperator {
+    [StorableConstructor]
+    protected TSPAfterCrossoverCombinedOperator(bool deserializing) : base(deserializing) { }
+    protected TSPAfterCrossoverCombinedOperator(TSPAfterCrossoverCombinedOperator original, Cloner cloner)
+      : base(original, cloner) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TSPAfterCrossoverCombinedOperator(this, cloner);
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterMutationCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterMutationCombinedOperator.cs	(revision 9042)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/TSPAfterMutationCombinedOperator.cs	(revision 9042)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("TSPAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for the TSP.")]
+  [StorableClass]
+  public class TSPAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+    [StorableConstructor]
+    protected TSPAfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
+    protected TSPAfterMutationCombinedOperator(TSPAfterMutationCombinedOperator original, Cloner cloner)
+      : base(original, cloner) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TSPAfterMutationCombinedOperator(this, cloner);
+    }
+  }
+}