Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs	(revision 9044)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/QAPAfterMutationCombinedOperator.cs	(revision 9045)
@@ -55,5 +55,5 @@
       mAnalyzer.PermutationAfterMutationParameter.ActualName = "Assignment";
 
-      varRemover.VariableNameParameter.Value.Value = "TSPTourClone";
+      varRemover.VariableNameParameter.Value.Value = "AssignmentClone";
     }
   }
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs	(revision 9045)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/CombinedOperators/TFAfterMutationCombinedOperator.cs	(revision 9045)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers {
+  [Item("TFAfterMutationCombinedOperator", "An operator that contains all operators that need to be executed after mutation for test functions.")]
+  [StorableClass]
+  public class TFAfterMutationCombinedOperator : AfterMutationCombinedOperator {
+
+    [StorableConstructor]
+    protected TFAfterMutationCombinedOperator(bool deserializing) : base(deserializing) { }
+    protected TFAfterMutationCombinedOperator(TFAfterMutationCombinedOperator original, Cloner cloner)
+      : base(original, cloner) {
+    }
+
+    public TFAfterMutationCombinedOperator()
+      : base() {
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TFAfterMutationCombinedOperator(this, cloner);
+    }
+
+    protected override void SimilarityCalculatorParameter_ValueChanged(object sender, System.EventArgs e) {
+      SimilarityCalculatorParameter.Value.QualityVariableName = "Quality";
+      SimilarityCalculatorParameter.Value.SolutionVariableName = "Point";
+    }
+
+    public override void InitializeOperators() {
+      base.InitializeOperators();
+      ((ILookupParameter)evaluatorClone.Parameters["Quality"]).ActualName = "QualityM";
+
+      mAnalyzer.QualityAfterCrossoverParameter.ActualName = "Quality";
+      mAnalyzer.QualityAfterMutationParameter.ActualName = "QualityM";
+      mAnalyzer.PermutationBeforeMutationParameter.ActualName = "PointClone";
+      mAnalyzer.PermutationAfterMutationParameter.ActualName = "Point";
+
+      varRemover.VariableNameParameter.Value.Value = "PointClone";
+    }
+  }
+}
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9044)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers-3.3.csproj	(revision 9045)
@@ -120,4 +120,5 @@
     <Compile Include="AfterCrossoverCombinedOperator.cs" />
     <Compile Include="AfterMutationCombinedOperator.cs" />
+    <Compile Include="CombinedOperators\TFAfterMutationCombinedOperator.cs" />
     <Compile Include="CombinedOperators\TFAfterCrossoverCombinedOperator.cs" />
     <Compile Include="CombinedOperators\TSPAfterMutationCombinedOperator.cs" />
Index: branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs
===================================================================
--- branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 9044)
+++ branches/HeuristicLab.Analysis.AlgorithmBehavior/HeuristicLab.Analysis.AlgorithmBehavior.Analyzers/3.3/MutationPerformanceAnalyzer.cs	(revision 9045)
@@ -25,5 +25,4 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
-using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
@@ -50,9 +49,9 @@
       get { return (ILookupParameter<DoubleValue>)Parameters["QualityAfterMutation"]; }
     }
-    public ILookupParameter<Permutation> PermutationBeforeMutationParameter {
-      get { return (ILookupParameter<Permutation>)Parameters["PermutationBeforeMutation"]; }
+    public ILookupParameter<IItem> PermutationBeforeMutationParameter {
+      get { return (ILookupParameter<IItem>)Parameters["PermutationBeforeMutation"]; }
     }
-    public ILookupParameter<Permutation> PermutationAfterMutationParameter {
-      get { return (ILookupParameter<Permutation>)Parameters["PermutationAfterMutation"]; }
+    public ILookupParameter<IItem> PermutationAfterMutationParameter {
+      get { return (ILookupParameter<IItem>)Parameters["PermutationAfterMutation"]; }
     }
     public ILookupParameter<ItemCollection<IItem>> OperatorsParameter {
@@ -96,8 +95,8 @@
       QualityAfterMutationParameter.ActualName = "TSPTourLengthM";
 
-      Parameters.Add(new LookupParameter<Permutation>("PermutationBeforeMutation"));
+      Parameters.Add(new LookupParameter<IItem>("PermutationBeforeMutation"));
       PermutationBeforeMutationParameter.ActualName = "TSPTourClone";
 
-      Parameters.Add(new LookupParameter<Permutation>("PermutationAfterMutation"));
+      Parameters.Add(new LookupParameter<IItem>("PermutationAfterMutation"));
       PermutationAfterMutationParameter.ActualName = "TSPTour";
 
@@ -117,4 +116,6 @@
         SimilarityCalculatorParameter.Value = OperatorsParameter.ActualValue.OfType<ISingleObjectiveSolutionSimilarityCalculator>().FirstOrDefault();
       }
+      qualityPlotHelper.InitializePlot(Results, "Mutation Quality", "Solution Index", "Absolut Quality Difference");
+      diversityPlotHelper.InitializePlot(Results, "Mutation Diversity", "Solution Index", "Diversity");
       Reset();
     }
@@ -126,29 +127,24 @@
       var qualityCX = QualityAfterCrossoverParameter.ActualValue.Value;
       var qualityM = QualityAfterMutationParameter.ActualValue.Value;
-      var permutationBefore = PermutationBeforeMutationParameter.ActualValue;
-      var permutationAfter = PermutationAfterMutationParameter.ActualValue;
+      var solutionBefore = PermutationBeforeMutationParameter.ActualValue;
+      var solutionAfter = PermutationAfterMutationParameter.ActualValue;
 
-      if (permutationBefore != null) {
-        qualityPlotHelper.InitializePlot(Results, "Mutation Quality", "Solution Index", "Absolut Quality Difference");
-        diversityPlotHelper.InitializePlot(Results, "Mutation Diversity", "Solution Index", "Diversity");
+      Scope permutationBeforeScope = new Scope();
+      Scope permutationAfterScope = new Scope();
+      permutationBeforeScope.Variables.Add(new Variable(PermutationAfterMutationParameter.ActualName, solutionBefore));
+      permutationAfterScope.Variables.Add(new Variable(PermutationAfterMutationParameter.ActualName, solutionAfter));
 
-        Scope permutationBeforeScope = new Scope();
-        Scope permutationAfterScope = new Scope();
-        permutationBeforeScope.Variables.Add(new Variable(PermutationAfterMutationParameter.ActualName, permutationBefore));
-        permutationAfterScope.Variables.Add(new Variable(PermutationAfterMutationParameter.ActualName, permutationAfter));
-
-        divPoint = new Point2D<double>(cnt, SimilarityCalculatorParameter.Value.CalculateSolutionSimilarity(permutationBeforeScope, permutationAfterScope));
-        curPoint = new Point2D<double>(cnt++, qualityCX - qualityM);
+      divPoint = new Point2D<double>(cnt, SimilarityCalculatorParameter.Value.CalculateSolutionSimilarity(permutationBeforeScope, permutationAfterScope));
+      curPoint = new Point2D<double>(cnt++, qualityCX - qualityM);
 
 
-        string curGenStr = GenerationsParameter.ActualValue.Value.ToString();
+      string curGenStr = GenerationsParameter.ActualValue.Value.ToString();
 
-        qualityPlotHelper.AddPoint(curGenStr, curPoint);
-        diversityPlotHelper.AddPoint(curGenStr, divPoint);
+      qualityPlotHelper.AddPoint(curGenStr, curPoint);
+      diversityPlotHelper.AddPoint(curGenStr, divPoint);
 
-        if (GenerationsParameter.ActualValue.Value != 0) {
-          if (GenerationsParameter.ActualValue.Value > lastGeneration) {
-            Reset();
-          }
+      if (GenerationsParameter.ActualValue.Value != 0) {
+        if (GenerationsParameter.ActualValue.Value > lastGeneration) {
+          Reset();
         }
       }